# Similar to etc/evergreen.yml, but for release builds.

include:
- filename: etc/evergreen_yml_components/configuration.yml
- filename: etc/evergreen_yml_components/definitions.yml
- filename: etc/evergreen_yml_components/variants/task_generation.yml
- filename: etc/evergreen_yml_components/variants/atlas.yml
- filename: etc/evergreen_yml_components/variants/misc_release.yml
### Comment out when using this file for a Rapid release branch. ###
- filename: etc/evergreen_yml_components/variants/ibm.yml
### Uncomment when using this file for a LTS release branch. ###
- filename: etc/evergreen_yml_components/variants/in_memory.yml
### Uncomment when using this file for a LTS or Rapid release branch. ###
- filename: etc/evergreen_yml_components/variants/sanitizer.yml
### Uncomment when using this file for a LTS or Rapid release branch. ###
- filename: etc/evergreen_yml_components/variants/ninja.yml
- filename: etc/evergreen_yml_components/variants/compile_static_analysis.yml
### Uncomment when using this file for a LTS or Rapid release branch. ###
- filename: etc/evergreen_yml_components/variants/classic_engine.yml
### Uncomment when using this file for a LTS or Rapid release branch. ###
# TODO: (SERVER-86211) Re-enable config shard evergreen variant.
# - filename: etc/evergreen_yml_components/variants/config_shard.yml
### Uncomment when using this file for a LTS or Rapid release branch. ###
- filename: etc/evergreen_yml_components/variants/try_sbe_engine.yml

parameters:
- key: evergreen_config_file_path
  value: "etc/evergreen_nightly.yml"
  description: "path to this file"


variables:
# Common compile variant dependency specifications.
- &linux_x86_dynamic_compile_variant_dependency
  depends_on:
  - name: archive_dist_test_debug
    variant: &linux_x86_dynamic_compile_variant_name linux-x86-dynamic-compile-required
  - name: version_gen
    variant: generate-tasks-for-version
    # This is added because of EVG-18211.
    # Without this we are adding extra dependencies on evergreen and it is causing strain
    omit_generated_tasks: true

- &linux_x86_dynamic_debug_compile_variant_dependency
  depends_on:
  - name: archive_dist_test_debug
    variant: &linux_x86_dynamic_debug_compile_variant_name linux-x86-dynamic-debug-compile-required
  - name: version_gen
    variant: generate-tasks-for-version
    # This is added because of EVG-18211.
    # Without this we are adding extra dependencies on evergreen and it is causing strain
    omit_generated_tasks: true

- &linux_debug_aubsan_compile_variant_dependency
  depends_on:
  - name: archive_dist_test_debug
    variant: &linux_debug_aubsan_compile_variant_name linux-debug-aubsan-compile-required
  - name: version_gen
    variant: generate-tasks-for-version
    # This is added because of EVG-18211.
    # Without this we are adding extra dependencies on evergreen and it is causing strain
    omit_generated_tasks: true

- &windows_compile_variant_dependency
  depends_on:
  - name: archive_dist_test_debug
    variant: &windows_compile_variant_name windows-compile-required
  - name: version_gen
    variant: generate-tasks-for-version
    # This is added because of EVG-18211.
    # Without this we are adding extra dependencies on evergreen and it is causing strain
    omit_generated_tasks: true

- &linux_x86_generic_expansions
  multiversion_platform: rhel80
  multiversion_platform_50_or_later: rhel8
  multiversion_edition: enterprise
  repo_edition: enterprise
  large_distro_name: rhel80-medium
  num_scons_link_jobs_available: 0.99
  compile_variant: *linux_x86_dynamic_compile_variant_name

# If you add anything to san_options, make sure the appropriate changes are
# also made to SConstruct.
# and also to the san_options in compile_static_analysis.yml
- aubsan_options: &aubsan_options
  >-
    UBSAN_OPTIONS="print_stacktrace=1:external_symbolizer_path=/opt/mongodbtoolchain/v4/bin/llvm-symbolizer"
    LSAN_OPTIONS="suppressions=etc/lsan.suppressions:report_objects=1"
    ASAN_OPTIONS="detect_leaks=1:check_initialization_order=true:strict_init_order=true:abort_on_error=1:disable_coredump=0:handle_abort=1:strict_string_checks=true:detect_invalid_pointer_pairs=1:external_symbolizer_path=/opt/mongodbtoolchain/v4/bin/llvm-symbolizer"


buildvariants:
- &linux-64-debug-required-template
  <<: *linux_x86_dynamic_debug_compile_variant_dependency
  name: &linux-64-debug-required linux-64-debug-required
  display_name: "! Linux x86 Shared Library DEBUG"
  cron: "0 */4 * * *" # From the ${project_required_suggested_cron} parameter
  run_on:
  - rhel80-medium
  expansions:
    resmoke_jobs_factor: 0.5  # Avoid starting too many mongod's
    test_flags: --excludeWithAnyTags=requires_http_client,requires_latch_analyzer --enableEnterpriseTests=off
    target_resmoke_time: 15
    max_sub_suites: 5
    large_distro_name: rhel80-medium
    compile_variant: *linux_x86_dynamic_debug_compile_variant_name
  tasks:
  - name: .aggregation !.encrypt !.feature_flag_guarded
  - name: .auth !.audit !.multiversion
  - name: sharding_auth_gen
  - name: .causally_consistent !.wo_snapshot
  - name: .change_streams
  - name: .clustered_collections
  - name: .misc_js
  - name: disk_wiredtiger
  - name: .jscore .common
  - name: jsCore_txns_large_txns_format
  - name: json_schema
  - name: query_golden_classic
  - name: libunwind_tests
  - name: .multi_shard
  - name: multi_stmt_txn_jscore_passthrough_with_migration_gen
  - name: .ocsp
  - name: .read_write_concern
  - name: .replica_sets !.encrypt !.ignore_non_generated_replica_sets_jscore_passthrough !.fcbis
  - name: replica_sets_jscore_passthrough_gen
  - name: replica_sets_reconfig_jscore_passthrough_gen
  - name: replica_sets_reconfig_jscore_stepdown_passthrough_gen
  - name: replica_sets_max_mirroring_large_txns_format_gen
  - name: .retry
  - name: .read_only
  - name: session_jscore_passthrough
  - name: sharded_multi_stmt_txn_jscore_passthrough
  - name: .sharding .jscore !.wo_snapshot
  - name: sharding_gen
  - name: sharding_max_mirroring_opportunistic_secondary_targeting_gen

- &enterprise-windows-template
  <<: *windows_compile_variant_dependency
  name: &enterprise-windows-required enterprise-windows-required
  display_name: "! Enterprise Windows"
  cron: "0 */4 * * *" # From the ${project_required_suggested_cron} parameter
  run_on:
  - windows-vsCurrent-small
  expansions: &windows_required_expansions
    compile_variant: *windows_compile_variant_name
    burn_in_tests_build_variant: enterprise-windows-all-feature-flags-required
    exe: ".exe"
    content_type: application/zip
    python: '/cygdrive/c/python/python37/python.exe'
    ext: zip
    multiversion_platform: windows
    multiversion_edition: enterprise
    jstestfuzz_num_generated_files: 35
    target_resmoke_time: 20
    max_sub_suites: 5
    large_distro_name: windows-vsCurrent-large
    push_path: windows
    push_bucket: downloads.10gen.com
    push_name: windows
    push_arch: x86_64-enterprise
    test_flags: --excludeWithAnyTags=incompatible_with_windows_tls,requires_latch_analyzer
    external_auth_jobs_max: 1
  tasks:
  - name: burn_in_tests_gen
    depends_on:
    - name: version_burn_in_gen
      variant: generate-tasks-for-version
      omit_generated_tasks: true
    - name: archive_dist_test_debug
      variant: *windows_compile_variant_name
  - name: audit
  - name: auth_audit_gen
  - name: buildscripts_test
  - name: causally_consistent_jscore_txns_passthrough
    distros:
    - windows-vsCurrent-large
  - name: .encrypt !.aggregation !.replica_sets !.sharding !.jscore
  - name: external_auth
  - name: external_auth_aws
  - name: external_auth_windows
    distros:
    - windows-2016-dc
  - name: .jscore .common !.sharding
  - name: jsCore_auth
  - name: jsCore_ese
  - name: jsCore_txns_large_txns_format
  - name: .jstestfuzz .common
  - name: noPassthrough_gen
  - name: noPassthroughWithMongod_gen
  - name: .replica_sets .common !.ignore_non_generated_replica_sets_jscore_passthrough
  - name: .replica_sets .multi_oplog !.ignore_non_generated_replica_sets_jscore_passthrough !.gcm
  - name: replica_sets_jscore_passthrough_gen
    distros:
    - windows-vsCurrent-large
  - name: sasl
  - name: sasl_windows_cyrussasl
  - name: .sharding .txns
  - name: sharding_auth_audit_gen
  - name: sharding_max_mirroring_opportunistic_secondary_targeting_ese_gen

- &enterprise-rhel-8-64-bit-dynamic-template
  <<: *linux_x86_dynamic_compile_variant_dependency
  name: &enterprise-rhel-8-64-bit-dynamic-required enterprise-rhel-8-64-bit-dynamic-required
  display_name: "! Shared Library Enterprise RHEL 8"
  cron: "0 */4 * * *" # From the ${project_required_suggested_cron} parameter
  run_on:
  - rhel80-small
  expansions: &enterprise-rhel-8-64-bit-dynamic-expansions
    <<: *linux_x86_generic_expansions
    scons_cache_scope: shared
    scons_cache_mode: all
    has_packages: false
    jstestfuzz_num_generated_files: 40
    jstestfuzz_concurrent_num_files: 10
    target_resmoke_time: 10
    max_sub_suites: 5
    idle_timeout_factor: 1.5
    exec_timeout_factor: 1.5
    large_distro_name: rhel80-medium
    burn_in_tag_buildvariants: >-
      enterprise-rhel-8-64-bit-inmem
      enterprise-rhel-8-64-bit-multiversion
    burn_in_tag_compile_task_dependency: archive_dist_test_debug
    test_flags: --excludeWithAnyTags=requires_latch_analyzer
  depends_on:
  - name: archive_dist_test_debug
    variant: *linux_x86_dynamic_compile_variant_name
  - name: version_gen
    variant: generate-tasks-for-version
    # This is added because of EVG-18211.
    # Without this we are adding extra dependencies on evergreen and it is causing strain
    omit_generated_tasks: true
  tasks:
  - name: burn_in_tests_gen
    depends_on:
    - name: version_burn_in_gen
      variant: generate-tasks-for-version
      omit_generated_tasks: true
    - name: archive_dist_test_debug
      variant: *linux_x86_dynamic_compile_variant_name
  - name: .aggfuzzer !.feature_flag_guarded
  - name: .aggregation !.feature_flag_guarded
  - name: aggregation_repeat_queries
  - name: analyze_shard_key_jscore_passthrough_gen
  - name: audit
  - name: .auth
  - name: buildscripts_test
  - name: unittest_shell_hang_analyzer_gen
  - name: .causally_consistent !.sharding
  - name: .change_streams
  - name: .change_stream_fuzzer
  - name: .misc_js
  - name: .concurrency !.large !.ubsan !.no_txns
  - name: .concurrency .large !.ubsan !.no_txns
    distros:
    - rhel80-medium
  - name: .config_fuzzer !.large
  - name: .config_fuzzer .large
    distros:
    - rhel80-medium
  - name: disk_wiredtiger
  - name: .encrypt
  - name: idl_tests
  - name: initial_sync_fuzzer_gen
  - name: jsCore
    distros:
    - rhel80-xlarge
  - name: .jscore .common !jsCore
  - name: jsCore_min_batch_repeat_queries_ese_gsm
  - name: jsCore_txns_large_txns_format
  - name: json_schema
  - name: .jstestfuzz !.flow_control  # Flow control jstestfuzz take longer.
  - name: libunwind_tests
  - name: .multi_shard
  - name: multi_stmt_txn_jscore_passthrough_with_migration_gen
  - name: multiversion_gen
  - name: .query_fuzzer
  - name: query_stats_aggregation_passthrough
  - name: query_stats_mongos_aggregation_passthrough
  - name: query_stats_mongos_passthrough
  - name: query_stats_passthrough
  - name: .random_multiversion_ds
  - name: .read_write_concern .large
    distros:
    - rhel80-medium
  - name: .read_write_concern !.large
  - name: .replica_sets !.encrypt !.auth
    distros:
    - rhel80-xlarge
  - name: replica_sets_api_version_jscore_passthrough_gen
  - name: replica_sets_reconfig_jscore_passthrough_gen
  - name: replica_sets_reconfig_jscore_stepdown_passthrough_gen
    distros:
    - rhel80-xlarge
  - name: replica_sets_reconfig_kill_primary_jscore_passthrough_gen
    distros:
    - rhel80-xlarge
  - name: retryable_writes_jscore_passthrough_gen
  - name: retryable_writes_jscore_stepdown_passthrough_gen
    distros:
    - rhel80-medium
  - name: .read_only
  - name: .rollbackfuzzer
  - name: sasl
  - name: search
  - name: search_auth
  - name: search_pinned_connections_auth
  - name: search_ssl
  - name: session_jscore_passthrough
  - name: .sharding .jscore !.wo_snapshot !.multi_stmt
  - name: sharding_api_version_jscore_passthrough_gen
  - name: sharding_api_strict_passthrough_gen
  - name: .sharding .txns
  - name: .sharding .common
  - name: .updatefuzzer
  - name: secondary_reads_passthrough_gen
  - name: .serverless
    distros:
    - rhel80-xlarge
  - name: vector_search
  - name: vector_search_auth
  - name: vector_search_ssl

- &rhel8-debug-aubsan-lite-template
  <<: *linux_debug_aubsan_compile_variant_dependency
  name: &rhel8-debug-aubsan-lite-required rhel8-debug-aubsan-lite-required
  display_name: "! Shared Library {A,UB}SAN Enterprise RHEL 8 DEBUG"
  cron: "0 */4 * * *" # From the ${project_required_suggested_cron} parameter
  run_on:
  - rhel80-build
  expansions: &aubsan-lite-required-expansions
    compile_variant: *linux_debug_aubsan_compile_variant_name
    lang_environment: LANG=C
    san_options: *aubsan_options
    test_flags: --excludeWithAnyTags=requires_ocsp_stapling,requires_latch_analyzer
    resmoke_jobs_factor: 0.3  # Avoid starting too many mongod's under {A,UB}SAN build.
    hang_analyzer_dump_core: false
    max_sub_suites: 3
    num_scons_link_jobs_available: 0.99
    large_distro_name: rhel80-build
    multiversion_platform: rhel80
    multiversion_platform_50_or_later: rhel8
    multiversion_edition: enterprise
    gcov_tool: /opt/mongodbtoolchain/v4/bin/gcov
  tasks:
  - name: jsCore
  - name: jsCore_txns

- name: run-all-affected-jstests
  display_name: "! Run All Affected JStests"
  patch_only: true
  run_on:
  - rhel80-medium
  expansions:
    large_distro_name: rhel80-large
    burn_in_tag_include_all_required_and_suggested: true
    burn_in_tag_exclude_build_variants: >-
      macos-debug-suggested
    burn_in_tag_include_build_variants: >-
      enterprise-rhel-8-64-bit-inmem
    burn_in_tag_compile_task_dependency: archive_dist_test_debug
    compile_variant: *linux_x86_dynamic_compile_variant_name
  depends_on:
  - name: archive_dist_test_debug
    variant: *linux_x86_dynamic_compile_variant_name
  - name: version_gen
    variant: generate-tasks-for-version
    # This is added because of EVG-18211.
    # Without this we are adding extra dependencies on evergreen and it is causing strain
    omit_generated_tasks: true
  - name: version_burn_in_gen
    variant: generate-tasks-for-version
    # This is added because of EVG-18211.
    # Without this we are adding extra dependencies on evergreen and it is causing strain
    omit_generated_tasks: true
  tasks:
  - name: burn_in_tags_gen

- <<: *enterprise-rhel-8-64-bit-dynamic-template
  name: &commit-queue commit-queue
  display_name: "~ Commit Queue"
  cron: "0 4 * * 0" # From the ${project_weekly_cron} parameter
  stepback: false
  expansions:
    <<: *linux_x86_generic_expansions
    scons_cache_scope: shared
    scons_cache_mode: all
    commit_queue_alternate_cache: linux-x86-dynamic-compile-required
    has_packages: false
    compile_flags: >-
      --ssl
      MONGO_DISTMOD=rhel80
      -j$(grep -c ^processor /proc/cpuinfo)
      --variables-files=etc/scons/mongodbtoolchain_stable_gcc.vars
      --link-model=dynamic
    crypt_task_compile_flags: >-
      SHLINKFLAGS_EXTRA="-Wl,-Bsymbolic
      -Wl,--no-gnu-unique"
      CCFLAGS="-fno-gnu-unique"
    clang_tidy_toolchain: v4
    num_scons_unit_cc_jobs_available: 0.75
    compile_variant: *commit-queue
    test_flags: --excludeWithAnyTags=requires_latch_analyzer
  depends_on: []
  tasks:
  - name: compile_ninja_quick_TG
    distros:
    - rhel80-xlarge-commitqueue
  - name: compile_test_and_package_parallel_core_stream_TG
    distros:
    - rhel80-xlarge-commitqueue
  - name: compile_test_and_package_parallel_unittest_stream_TG
    distros:
    - rhel80-xlarge-commitqueue
  - name: compile_test_and_package_parallel_dbtest_stream_TG
    distros:
    - rhel80-xlarge-commitqueue
  - name: jsCore
    distros:
    - rhel80-xlarge-commitqueue
  - name: .lint
  - name: test_api_version_compatibility
  - name: validate_commit_message
  - name: check_feature_flag_tags
  - name: compile_venv_deps_check
  - name: resmoke_validation_tests

###########################################
#          Copybara buildvariants           #
###########################################

- name: &copybara-sync-between-repos copybara-sync-between-repos
  display_name: "* Copybara Sync Between Repos"
  activate: true
  run_on:
  - ubuntu2204-small
  stepback: false
  tasks:
  - name: sync_repo_with_copybara
    priority: 50
